local B = CBW_Battle

B.BattleProjectileDamage = function(target,inflictor,source,something,damage)
	if not(B.BattleGametype()) then return nil end
	if not(inflictor and inflictor.valid) then return nil end
	if not(inflictor.flags&(MF_MISSILE|MF_ENEMY)) then return nil end
	if not(source and source.player and target.player) then return nil end
	if (target.player.pflags&PF_TAGIT) then return false end

	if not(B.PlayerCanBeDamaged(target.player) or inflictor.flags2&MF2_SUPERFIRE) then return nil end
	local element = damage&~(DMG_CANHURTSELF)
	if (element == DMG_WATER and target.player.powers[pw_shield]&SH_PROTECTWATER)
		or (element == DMG_FIRE and target.player.powers[pw_shield]&SH_PROTECTFIRE)
		or (element == DMG_ELECTRIC and target.player.powers[pw_shield]&SH_PROTECTELECTRIC)
		or (element == DMG_SPIKE and target.player.powers[pw_shield]&SH_PROTECTSPIKE)
		then
		return nil
	end
	if (gametype == GT_EGGROBOTAG and source.player.pflags&PF_TAGIT) and not(target.player.pflags&PF_TAGIT)
		then
		print(target.player.name.." has been found!")
		target.player.pflags = $|PF_TAGIT
		return true
	end
	if not(B.MyTeam(target.player,source.player))
		return true
	else
		return nil
	end
end

B.PlayerCanBeDamaged = function(player)
	if not(player.playerstate == PST_LIVE) then return false end
	if player.powers[pw_invulnerability] then return false end
	if player.powers[pw_super] then return false end
	if player.powers[pw_flashing] then return false end
	return true
end