local B = CBW_Battle

B.TagGametype = function()
	if gametype == GT_EGGROBOTAG or G_TagGametype() then return true
	else return false end
end

B.BattleGametype = function()
	if gametype and B.Gametypes.Battle[gametype] then return true
	else return false end
end

B.CPGametype = function()
	if gametype and B.Gametypes.CP[gametype] then return true
	else return false end
end

B.TeamBattleScore = function()
	if not(G_GametypeHasTeams() and gametype and B.Gametypes.TeamScoreType[gametype] == 1) then return end
	for player in players.iterate()
		if player.scorelast == nil then
			player.scorelast = player.score
		end
		local score = max(0,player.score-player.scorelast)
		if player.ctfteam == 1 then
			redscore = $+score
		elseif player.ctfteam == 2 then
			bluescore = $+score
		end
		player.scorelast = player.score
	end
end

